import java.util.Properties;


public class CrowdingGA_withMirrorDistance_absoluteMutation extends CrowdingGA_withMirrorDistance {
	
	CrowdingGA_withMirrorDistance_absoluteMutation(Properties props, Landscape lscape, int rand_seed){
		super(props, lscape, rand_seed);
		ea_type = "CrowdingGA_withMirrorDistance_absoluteMutation";
	}
	
	@Override
	void run(int birth_limit)
	{
		birth_cnt = 0;
		generation_cnt = 0;
		NFE = 0;
		global_max.fitness = Float.NEGATIVE_INFINITY;
		global_min.fitness = Float.POSITIVE_INFINITY;
		parent_pop.run_reset();
		dump();
		
		if(crowdingFactor==0){
			Util.ec_error("Crowding Factor == 0 !"); System.exit(-1);
		}
		while ( (birth_cnt < birth_limit) & (NFE <= EC4.maxNFE) ) 
		{
			if (report_fixed_gen || report_fixed_fit)  if (parent_pop.fixed_point()) {
				break;
			}

			offspring_pop = select_and_clone_parents();

			introduce_offspring_variation_withAbsoluteMutation();

			evaluate_offspring();

			/***************************************************/
			/***********Crowding Selection**********************/
			/***************************************************/
			Individual[] temp = new Individual[parent_pop.pop_size];
			float min_fitness = Float.MAX_VALUE;
			for(int k=0; k<parent_pop.pop_size; k++){
				temp[k] = parent_pop.indiv[k];
				if(min_fitness>temp[k].fitness){
					min_fitness = temp[k].fitness;
				}
			}

			for(int i=0; i<offspring_pop.indiv.length; i++){
				if(offspring_pop.indiv[i].fitness>=min_fitness){
					int NN = nearestNeighborInt(offspring_pop.indiv[i].genome, temp, crowdingFactor);	//**it uses parent_pop
					if(offspring_pop.indiv[i].fitness>temp[NN].fitness){
						temp[NN] = offspring_pop.indiv[i];
					}
				}
			}
			parent_pop.indiv = temp;
			/*******************END******************************/

			generation_cnt ++;
			dump();
//			adapt_operators();
//			adaptation_stats();
		}
		
	}
	
    final int uniform_stochastic = 1;
    final int uniform_deterministic = 2;
    final int fitness_proportional = 3;
    final int rank_proportional = 4;
    final int binary_tournament = 5;
    final int truncation = 6;
    void introduce_offspring_variation_withAbsoluteMutation()
    {

    	if (use_recombination) switch(mate_selection_type) {

    	case fitness_proportional:
    		offspring_pop.mate_fprop(parent_pop);
    		break;

    	case uniform_stochastic:
    		offspring_pop.mate_unif_sto(parent_pop);
    		break;

    	case uniform_deterministic:
    		offspring_pop.mate_unif_det(parent_pop);
    		break;

    	case binary_tournament:
    		offspring_pop.mate_btourn(parent_pop);
    		break;

    	default:
    		Util.ec_error("illegal mate selection type: " + mate_selection_type);
    	}

    	if (use_mutation){
    		if(offspring_pop.indiv[0].genome instanceof RelativeEncodingGenome){
    			for(Individual ind : offspring_pop.indiv){
    				if (rand.frand() > Genome.mutation_probability){ 
	    				RelativeEncodingGenome a = (RelativeEncodingGenome)ind.genome;
	    				char mutatedChar = RelativeEncodingGenome.alphabet[rand.irand(RelativeEncodingGenome.alphabet.length)];
	    				int index = rand.irand(a.gene.length);
	    				a.absoluteMutate(index, mutatedChar);
    				}else{
    					ind.mutate(this);
    				}
    			}
    		}else{
    			offspring_pop.mutate();
    		}
    	}

    	return;
    }
	
}
