
abstract class RelativeEncodingLscape extends LatticeModelLscape{
	
	public static final String deltaX_cmdList	= "XyYZz";
	public static final String deltaXN_cmdList	= "xYyZz";
	public static final String deltaY_cmdList	= "YXxzZ";
	public static final String deltaYN_cmdList	= "yxXZz";
	public static final String deltaZ_cmdList	= "ZXxYy";
	public static final String deltaZN_cmdList	= "zXxyY";
//	public static final String deltaZN_cmdList	= "zxXyY";
		
	
	@Override
	final float eval(char param[])
	{
		float fitness = 0;

		int coordinates[][] = convertToCoordinates(param);

		int i,j,k,dist;
		for(i=0; i<seq.length(); i++){
			for(j=i+3; j<seq.length(); j=j+1){
				dist = 0;
				for(k=0; k<coordinates[i].length; k++){
					dist += Math.abs(coordinates[i][k]-coordinates[j][k]);
					if(dist>1)break;
				}
				if(dist==0){
					fitness = -999999; break;
				}else if(dist==1){
					if(seq.charAt(i)=='h' && seq.charAt(j)=='h')
						fitness++;
				}
			}
			if(fitness<0)break;
		}

		return fitness;   // constraint violation
	}
	
	@Override
	boolean legal(char param[]){
		int coordinates[][] = convertToCoordinates(param);

		for(int i=0; i<seq.length(); i++){
			for(int j=i+4; j<seq.length(); j=j+2){
				
				boolean collision=true;
				for(int k=0; k<coordinates[i].length; k++){
					if(coordinates[i][k]!=coordinates[j][k]){
						collision=false;
						break;
					}
				}
				if(collision){
					return false;
				}
				
			}
		}

		return true;
	}
    
    final int[][] convertToCoordinates(char[] LMrelativeEncoding){
		int points[][] = new int[LMrelativeEncoding.length+2][3];
		points[0][0] = 0; points[0][1] = 0; points[0][2] = 0;	//xyz
		points[1][0] = 1; points[1][1] = 0; points[1][2] = 0;
		for(int i=0; i<LMrelativeEncoding.length; i++){

			int deltaX = points[i+1][0]-points[i][0];
			int deltaY = points[i+1][1]-points[i][1];
			int deltaZ = points[i+1][2]-points[i][2];

			//checking
			if((deltaX+deltaY+deltaZ)!=1 && (deltaX+deltaY+deltaZ)!=-1){
				System.out.println("Delta Error: "+deltaX+" "+deltaY+" "+deltaZ);
				System.exit(-1);
			}
			
			if(deltaX==1){
				setPoint(points, i+2, LMrelativeEncoding[i], deltaX_cmdList);
			}else if(deltaX==-1){
				setPoint(points, i+2, LMrelativeEncoding[i], deltaXN_cmdList);
			}else if(deltaY==1){
				setPoint(points, i+2, LMrelativeEncoding[i], deltaY_cmdList);
			}else if(deltaY==-1){
				setPoint(points, i+2, LMrelativeEncoding[i], deltaYN_cmdList);
			}else if(deltaZ==1){
				setPoint(points, i+2, LMrelativeEncoding[i], deltaZ_cmdList);
			}else if(deltaZ==-1){
				setPoint(points, i+2, LMrelativeEncoding[i], deltaZN_cmdList);
			}else{
				System.out.println("Delta Error: "+deltaX+" "+deltaY+" "+deltaZ);
				System.exit(-1);
			}
			
//			if(deltaX==1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "XyYZz");
//			}else if(deltaX==-1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "xYyZz");
//			}else if(deltaY==1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "YXxzZ");
//			}else if(deltaY==-1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "yxXzZ");
//			}else if(deltaZ==1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "ZXxYy");
//			}else if(deltaZ==-1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "zxXYy");
//			}else{
//				System.out.println("Delta Error: "+deltaX+" "+deltaY+" "+deltaZ);
//				System.exit(-1);
//			}

//			if(deltaX==1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "XyYZz");
//			}else if(deltaX==-1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "xYyZz");
//			}else if(deltaY==1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "YXxZz");
//			}else if(deltaY==-1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "yxXZz");
//			}else if(deltaZ==1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "ZXxyY");
//			}else if(deltaZ==-1){
//				setPoint(points, i+2, LMrelativeEncoding[i], "zXxYy");
//			}else{
//				System.out.println("Delta Error: "+deltaX+" "+deltaY+" "+deltaZ);
//				System.exit(-1);
//			}

		}
		return points;
	}

	private final void setPoint(int[][] points, int index, char relativeEncoding, String cmdList){
		if(cmdList.length()!=5){
			System.out.println("Error cmdList.length != 5");
			System.exit(-1);
		}
		switch(relativeEncoding){
		case 'F':
			setPointByCMD(points, index, cmdList.charAt(0));
			break;
		case 'R':
			setPointByCMD(points, index, cmdList.charAt(1));
			break;
		case 'L':
			setPointByCMD(points, index, cmdList.charAt(2));
			break;
		case 'U':
			setPointByCMD(points, index, cmdList.charAt(3));
			break;
		case 'D':
			setPointByCMD(points, index, cmdList.charAt(4));
			break;
		default:
			setPointByCMD(points, index, cmdList.charAt(0));
			break;
		}
	}

	private final  void setPointByCMD(int[][] points, int index, char cmd){
		switch(cmd){
		case 'X':
			points[index][0] = points[index-1][0]+1;
			points[index][1] = points[index-1][1];
			points[index][2] = points[index-1][2];
			break;
		case 'x':
			points[index][0] = points[index-1][0]-1;
			points[index][1] = points[index-1][1];
			points[index][2] = points[index-1][2];
			break;
		case 'Y':
			points[index][0] = points[index-1][0];
			points[index][1] = points[index-1][1]+1;
			points[index][2] = points[index-1][2];
			break;
		case 'y':
			points[index][0] = points[index-1][0];
			points[index][1] = points[index-1][1]-1;
			points[index][2] = points[index-1][2];
			break;
		case 'Z':
			points[index][0] = points[index-1][0];
			points[index][1] = points[index-1][1];
			points[index][2] = points[index-1][2]+1;
			break;
		case 'z':
			points[index][0] = points[index-1][0];
			points[index][1] = points[index-1][1];
			points[index][2] = points[index-1][2]-1;
			break;
		default:
			points[index][0] = points[index-1][0];
			points[index][1] = points[index-1][1];
			points[index][2] = points[index-1][2];
			break;
		}
	}
}
