import java.util.Properties;
import java.util.StringTokenizer;


public class SharingGA extends EA{
	
	double scaling;
	double nicheRadius;
	SharingGA(Properties props, Landscape lscape, int rand_seed){
	    super(rand_seed);
	    ea_type = "SharingGA";
	    EA_init(props, lscape);         // finish general EA initialization;
	    
	    StringTokenizer st = new StringTokenizer(props.getProperty("EA")," ");
	    st.nextToken();
	    if(st.hasMoreTokens()){
	    	scaling = Double.parseDouble(st.nextToken());
	    }else{
	    	scaling = 1;
	    }
	    if(st.hasMoreTokens()){
	    	nicheRadius = Double.parseDouble(st.nextToken());
	    }else{
	    	nicheRadius = 5;
	    }
	    
	    System.out.println("SharingGA: It uses Scaling="+scaling+" & NicheRadius="+nicheRadius);
	    
	    
    }
	
	/*
	   run: the specified EA for the specified time
	*/
	
	void run(int birth_limit)
	{
		birth_cnt = 0;
		generation_cnt = 0;
		NFE = 0;
		global_max.fitness = Float.NEGATIVE_INFINITY;
		global_min.fitness = Float.POSITIVE_INFINITY;
		parent_pop.run_reset();
		dump();
		
		if(nicheRadius==0 || scaling==0){
			Util.ec_error("nicheRadius or scaling == 0 !"); System.exit(-1);
		}
		while ( (birth_cnt < birth_limit) & (NFE <= EC4.maxNFE) ) 
		{
			if (report_fixed_gen || report_fixed_fit)  if (parent_pop.fixed_point()) {
				break;
			}

			offspring_pop = select_and_clone_parents();

			introduce_offspring_variation();

			evaluate_offspring();
			
			offspring_pop.sharingEvaluate(scaling, nicheRadius);

			select_survivors();

			generation_cnt ++;
			dump();
//			adapt_operators();
//			adaptation_stats();
		}
		parent_pop.evaluate(); //change back to normal fitness
		
	}
	
	//to be written
	void adapt_operators(){}
	void adaptation_stats(){}
}
